Coin: SbBox2d Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SbBox2d Class Reference
Base Classes

The SbBox2d class is a 2 dimensional box with double precision corner coordinates. More...

`#include <Inventor/SbBox2d.h>`

## Public Member Functions
| SbBox2d (void)
| SbBox2d (double xmin, double ymin, double xmax, double ymax)
| SbBox2d (const SbVec2d &minpoint, const SbVec2d &maxpoint)
| SbBox2d (const SbBox2f &box)
| SbBox2d (const SbBox2s &box)
| SbBox2d (const SbBox2i32 &box)
SbBox2d & | setBounds (double xmin, double ymin, double xmax, double ymax)
SbBox2d & | setBounds (const SbVec2d &minpoint, const SbVec2d &maxpoint)
SbBox2d & | setBounds (const SbBox2f &box)
SbBox2d & | setBounds (const SbBox2s &box)
SbBox2d & | setBounds (const SbBox2i32 &box)
void | getBounds (double &xmin, double &ymin, double &xmax, double &ymax) const
void | getBounds (SbVec2d &minpoint, SbVec2d &maxpoint) const
const SbVec2d & | getMin (void) const
SbVec2d & | getMin (void)
const SbVec2d & | getMax (void) const
SbVec2d & | getMax (void)
void | extendBy (const SbVec2d &point)
void | extendBy (const SbBox2d &box)
void | makeEmpty (void)
SbBool | isEmpty (void) const
SbBool | hasArea (void) const
SbBool | intersect (const SbVec2d &point) const
SbBool | intersect (const SbBox2d &box) const
SbVec2d | getClosestPoint (const SbVec2d &p) const
SbBool | findIntersection (const SbVec2d &a, const SbVec2d &b, SbVec2d &ia, SbVec2d &ib) const
SbVec2d | getCenter (void) const
void | getOrigin (double &originX, double &originY) const
void | getSize (double &sizeX, double &sizeY) const
SbVec2d | getSize (void) const
double | getAspectRatio (void) const

## Related Symbols
(Note that these are not member symbols.)
int | operator== (const SbBox2d &b1, const SbBox2d &b2)
int | operator!= (const SbBox2d &b1, const SbBox2d &b2)

## Detailed Description

The SbBox2d class is a 2 dimensional box with double precision corner coordinates.

This box class is used by many other classes in Coin for data exchange and storage. It provides two box corners with double precision coordinates, which is among other things useful for representing screen or canvas dimensions in normalized coordinates.

This class is a Coin extension.

See also
  SbBox2s, SbBox2f, SbBox3s, SbBox3f, SbBox3d, SbXfBox3f.

Since
  Coin 2.0
  TGS Inventor 2.6

## Constructor & Destructor Documentation

## ◆ SbBox2d() [1/6]

SbBox2d::SbBox2d | ( | void |  | ) |
| inline

The default constructor makes an empty box.

## ◆ SbBox2d() [2/6]

SbBox2d::SbBox2d | ( | double | xmin,
|  | double | ymin,
|  | double | xmax,
|  | double | ymax )
| inline

Constructs a box with the given corners.

xmin should be less than xmax and ymin should be less than ymax if you want to make a valid box.

## ◆ SbBox2d() [3/6]

SbBox2d::SbBox2d | ( | const SbVec2d & | min,
|  | const SbVec2d & | max )
| inline

Constructs a box with the given lower left and upper right corners.

The coordinates of min should be less than the coordinates of max if you want to make a valid box.

## ◆ SbBox2d() [4/6]

SbBox2d::SbBox2d | ( | const SbBox2f & | box | ) |
| inlineexplicit

Constructs an SbBox2d instance from the value in an SbBox2f instance.

Since
  Coin 2.5

## ◆ SbBox2d() [5/6]

SbBox2d::SbBox2d | ( | const SbBox2s & | box | ) |
| inlineexplicit

Constructs an SbBox2d instance from the value in an SbBox2s instance.

Since
  Coin 2.5

## ◆ SbBox2d() [6/6]

SbBox2d::SbBox2d | ( | const SbBox2i32 & | box | ) |
| inlineexplicit

Constructs an SbBox2d instance from the value in an SbBox2i32 instance.

Since
  Coin 2.5

## Member Function Documentation

## ◆ setBounds() [1/5]

SbBox2d & SbBox2d::setBounds | ( | double | xmin,
|  | double | ymin,
|  | double | xmax,
|  | double | ymax )
| inline

Reset the boundaries of the box.

xmin should be less than xmax and ymin should be less than ymax if you want to make a valid box.

Returns reference to self.

See also
  getBounds().

## ◆ setBounds() [2/5]

SbBox2d & SbBox2d::setBounds | ( | const SbVec2d & | min,
|  | const SbVec2d & | max )
| inline

Reset the boundaries of the box with the given corners.

The coordinates of min should be less than the coordinates of max if you want to make a valid box.

Returns reference to self.

See also
  getBounds().

## ◆ setBounds() [3/5]

SbBox2d & SbBox2d::setBounds | ( | const SbBox2f & | box | ) |

Reset the boundaries of the box with the given box boundaries.

Returns reference to self.

See also
  getBounds()

## ◆ setBounds() [4/5]

SbBox2d & SbBox2d::setBounds | ( | const SbBox2s & | box | ) |

Reset the boundaries of the box with the given box boundaries.

Returns reference to self.

See also
  getBounds()

## ◆ setBounds() [5/5]

SbBox2d & SbBox2d::setBounds | ( | const SbBox2i32 & | box | ) |

Reset the boundaries of the box with the given box boundaries.

Returns reference to self.

See also
  getBounds()

## ◆ getBounds() [1/2]

void SbBox2d::getBounds | ( | double & | xmin,
|  | double & | ymin,
|  | double & | xmax,
|  | double & | ymax ) const
| inline

Returns the box boundaries.

See also
  setBounds(), getMin(), getMax().

## ◆ getBounds() [2/2]

void SbBox2d::getBounds | ( | SbVec2d & | min,
|  | SbVec2d & | max ) const
| inline

Returns the box min and max corner points.

See also
  setBounds(), getMin(), getMax().

## ◆ getMin() [1/2]

const SbVec2d & SbBox2d::getMin | ( | void |  | ) | const
| inline

Returns the lower left corner of the box.

See also
  getOrigin(), getMax().

## ◆ getMin() [2/2]

SbVec2d & SbBox2d::getMin | ( | void |  | ) |
| inline

Returns the lower left corner of the box.

See also
  getOrigin(), getMax().

## ◆ getMax() [1/2]

const SbVec2d & SbBox2d::getMax | ( | void |  | ) | const
| inline

Returns the upper right corner of the box.

See also
  getMin().

## ◆ getMax() [2/2]

SbVec2d & SbBox2d::getMax | ( | void |  | ) |
| inline

Returns the upper right corner of the box.

See also
  getMin().

## ◆ extendBy() [1/2]

void SbBox2d::extendBy | ( | const SbVec2d & | point | ) |

Extend the boundaries of the box by the given point, i.e. make the box fit around the point if it isn't already situated within it.

## ◆ extendBy() [2/2]

void SbBox2d::extendBy | ( | const SbBox2d & | box | ) |

Extend the boundaries of the box by the given box parameter. This is equal to calling the above method twice with the corner points.

## ◆ makeEmpty()

void SbBox2d::makeEmpty | ( | void |  | ) |

Marks this as an empty box.

See also
  isEmpty().

## ◆ isEmpty()

SbBool SbBox2d::isEmpty | ( | void |  | ) | const
| inline

Check if this has been marked as an empty box.

See also
  makeEmpty().

## ◆ hasArea()

SbBool SbBox2d::hasArea | ( | void |  | ) | const
| inline

Check if the box has been correctly specified and by that virtue has "positive" area, i.e. all coordinates of its upper right corner (the maximum point) are greater than the corresponding coordinates of its lower left corner (the minimum point).

## ◆ intersect() [1/2]

SbBool SbBox2d::intersect | ( | const SbVec2d & | point | ) | const

Check if point lies within the boundaries of this box.

## ◆ intersect() [2/2]

SbBool SbBox2d::intersect | ( | const SbBox2d & | box | ) | const

Check if box lies entirely or partially within the boundaries of this box.

## ◆ getClosestPoint()

SbVec2d SbBox2d::getClosestPoint | ( | const SbVec2d & | point | ) | const

Return the point on the box closest to the given point p. If the given point equals the center, the center point on the positive X-side is returned.

## ◆ findIntersection()

SbBool SbBox2d::findIntersection | ( | const SbVec2d & | a,
|  | const SbVec2d & | b,
|  | SbVec2d & | ia,
|  | SbVec2d & | ib ) const

Check if a a line from a to b intersects the box, and return the coordinates of the union line in ia and ib.

This function is a Coin extension.

## ◆ getCenter()

SbVec2d SbBox2d::getCenter | ( | void |  | ) | const
| inline

Returns the center point of the box.

## ◆ getOrigin()

void SbBox2d::getOrigin | ( | double & | originX,
|  | double & | originY ) const
| inline

Returns the coordinates of the box origin (i.e. the lower left corner).

See also
  getMin().

## ◆ getSize() [1/2]

void SbBox2d::getSize | ( | double & | sizeX,
|  | double & | sizeY ) const
| inline

Returns width and height of box.

## ◆ getSize() [2/2]

SbVec2d SbBox2d::getSize | ( | void |  | ) | const
| inline

Returns width and height of box as a 2D vector.

Since
  Coin 3.0

## ◆ getAspectRatio()

double SbBox2d::getAspectRatio | ( | void |  | ) | const
| inline

Returns aspect ratio of box, which is defined as box width divided on box height.

## Friends And Related Symbol Documentation

## ◆ operator==()

int operator== | ( | const SbBox2d & | b1,
|  | const SbBox2d & | b2 )
| related

Check b1 and b2 for equality.

## ◆ operator!=()

int operator!= | ( | const SbBox2d & | b1,
|  | const SbBox2d & | b2 )
| related

Check b1 and b2 for inequality.

The documentation for this class was generated from the following files:

- SbBox2d.h
- SbBox2d.cpp